---
title: text-underline-position
slug: Web/CSS/text-underline-position
tags:
  - CSS
  - CSS Property
  - CSS Text Decoration
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>text-underline-position</code></strong> <a href="/en-US/docs/CSS">CSS </a>property specifies the position of the underline which is set using the {{cssxref("text-decoration")}} property's <code>underline</code> value.</p>

<div>{{EmbedInteractiveExample("pages/css/text-underline-position.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-numbers notranslate">/* Single keyword */
text-underline-position: auto;
text-underline-position: under;
text-underline-position: left;
text-underline-position: right;

/* Multiple keywords */
text-underline-position: under left;
text-underline-position: right under;

/* Global values */
text-underline-position: inherit;
text-underline-position: initial;
text-underline-position: unset;
</pre>

<h2 id="Syntax_2">Syntax</h2>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>auto</code></dt>
 <dd>The {{glossary("user agent")}} uses its own algorithm to place the line at or under the alphabetic baseline.</dd>
 <dt><code>from-font</code></dt>
 <dd>If the font file includes information about a preferred position, use that value. If the font file doesn't include this information, behave as if <code>auto</code> was set, with the browser choosing an appropriate position.</dd>
 <dt><code>under</code></dt>
 <dd>Forces the line to be set below the alphabetic baseline, at a position where it won't cross any descenders. This is useful for ensuring legibility with chemical and mathematical formulas, which make a large use of subscripts.</dd>
 <dt><code>left</code></dt>
 <dd>In vertical writing-modes, this keyword forces the line to be placed on the <em>left</em> side of the text. In horizontal writing-modes, it is a synonym of <code>under</code>.</dd>
 <dt><code>right</code></dt>
 <dd>In vertical writing-modes, this keyword forces the line to be placed on the <em>right</em> side of the text. In horizontal writing-modes, it is a synonym of <code>under</code>.</dd>
 <dt><code>auto-pos</code> {{non-standard_inline}}</dt>
 <dd>A synonym of <code>auto</code>, which should be used instead.</dd>
 <dt><code>above</code> {{non-standard_inline}}</dt>
 <dd>Forces the line to be above the text. When used with East-Asian text, using the <code>auto</code> keyword will lead to a similar effect.</dd>
 <dt><code>below</code> {{non-standard_inline}}</dt>
 <dd>Forces the line to be below the text. When used with alphabetic text, using the <code>auto</code> keyword will lead to a similar effect.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="A_simple_example">A simple example</h3>

<p>Let's take a couple of simple example paragraphs:</p>

<pre class="brush: html notranslate">&lt;p class="horizontal"&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit.
Nullam consectetur ac turpis vel laoreet. Nullam volutpat pharetra lorem, sit
amet feugiat tortor volutpat quis. Nam eget sodales quam. Aliquam accumsan
tellus ac erat posuere.&lt;/p&gt;

&lt;p class="vertical"&gt;Lorem ipsum dolor sit amet, consectetur adipiscing elit.
Nullam consectetur ac turpis vel laoreet. Nullam volutpat pharetra lorem, sit
amet feugiat tortor volutpat quis. Nam eget sodales quam. Aliquam accumsan
tellus ac erat posuere.&lt;/p&gt;</pre>

<p>Our CSS looks like this:</p>

<pre class="brush: css notranslate">p {
  font-size: 1.5rem;
  text-transform: capitalize;
  text-decoration: underline;
  text-decoration-thickness: 2px;
}

.horizontal {
  text-underline-position: under;
}

.vertical {
  writing-mode: vertical-rl;
  text-underline-position: left;
}</pre>

<p>In this example we set both the paragraphs to have a thick underline. In the horizontal text we use <code>text-underline-position: under;</code> to put the underline below all the descenders.</p>

<p>In the text with a vertical <code><a href="/en-US/docs/Web/CSS/writing-mode">writing-mode</a></code> set, we can then use values of <code>left</code> or <code>right</code> to make the underline appear on the left or right of the text as required.</p>

<p>The live example looks like this:</p>

<p>{{EmbedLiveSample('A_simple_example', '100%', 600)}}</p>

<h3 id="Setting_text-underline-position_globally">Setting text-underline-position globally</h3>

<p>Because the <code>text-underline-position</code> property inherits and is not reset by the {{cssxref("text-decoration")}} shorthand property, it may be appropriate to set its value at a global level. For example, the <code>under</code> value may be appropriate for a document with lots of chemical and mathematical formulas, which make a large use of subscripts.</p>

<pre class="brush: css notranslate">:root {
  text-underline-position: under;
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Text Decoration', '#text-underline-position-property', 'text-underline-position')}}</td>
   <td>{{Spec2('CSS3 Text Decoration')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.text-underline-position")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{cssxref("text-decoration")}} property is a shorthand for setting most text-decoration properties, including {{cssxref("text-decoration-line")}}, {{cssxref("text-decoration-color")}}, and {{cssxref("text-decoration-style")}}. However, it does not set <code>text-underline-position</code>.</li>
 <li>Microsoft <a href="http://msdn.microsoft.com/en-us/library/ie/ms531176%28v=vs.85%29.aspx">non-standard values documentation</a></li>
</ul>
